/* Auteur: Nicolas JANEY          */
/* nicolas.janey@univ-fcomte.fr   */
/* Fevrier 2005                   */

public class TestMatriceMagiqueEnConsole {

  public static int sommeColonneMatrice(int [][] m,int c) {
    int s = 0;
    int n = m.length;
    for ( int i = 0 ; i < n ; i++ )
      s += m[i][c];
    return(s);
  }

  public static int sommeLigneMatrice(int [][] m,int l) {
    int s = 0;
    int n = m.length;
    for ( int i = 0 ; i < n ; i++ )
      s += m[l][i];
    return(s);
  }

  public static int sommeDiagonale1Matrice(int [][] m,int d) {
    int s = 0;
    int n = m.length;
    for ( int i = 0 ; i < n ; i++ )
      s += m[i][(d+i)%n];
    return(s);
  }

  public static int sommeDiagonale2Matrice(int [][] m,int d) {
    int s = 0;
    int n = m.length;
    for ( int i = 0 ; i < n ; i++ )
      s += m[i][(d+n-i)%n];
    return(s);
  }

  public static boolean testMatriceMagique(int [][] m) {
    int n = m.length;
    int v = sommeColonneMatrice(m,0);
    for ( int i = 1 ; i < n ; i++ )
      if ( v != sommeColonneMatrice(m,i) )
        return(false);
    for ( int i = 0 ; i < n ; i++ )
      if ( v != sommeLigneMatrice(m,i) )
        return(false);
    for ( int i = 0 ; i < n ; i++ )
      if ( v != sommeDiagonale1Matrice(m,i) )
        return(false);
    for ( int i = 0 ; i < n ; i++ )
      if ( v != sommeDiagonale2Matrice(m,i) )
        return(false);
    return(true);
  }

  /* Fonction de creation d'une matrice carree d'entiers  */
  /* initialisee avec des nombres aleatoires              */
  /* n : nombres de lignes et de colonnes de la matrice   */
  /* max : valeur maximale des nombres aleatoires         */
  /* Resultat fonction : Matrice d'entiers                */

  public static int [][] creationMatriceAleatoire(int n,int max) {
  /* Allocation de la matrice                             */
    int [][] m = new int[n][n];
  /* Pour toutes les lignes de la matrice a initialiser   */
    for ( int i = 0 ; i < n ; i++ )
  /* Pour toutes les colonnes de la matrice a initialiser */
      for ( int j = 0 ; j < n ; j++ ) {
  /* Initialisation avec un nombre aleatoire compris      */
  /* entre 0 et max                                       */
        m[i][j] =(int) (Math.random()*(max+1)); }
  /* Resultat de la fonction                              */
    return(m);
  }

  public static int [][] matriceMagique(int n) {
    if ( n == 4 ) {
      int [][] m = { { 7,12,1,14 } , { 2,13,8,11 } , { 16,3,10,5 } , { 9,6,15,4 } };
      return(m); }
    if ( n == 5 ) {
      int [][] m = { { 1,15,24,8,17 } , { 23,7,16,5,14 } , { 20,4,13,22,6 } , { 12,21,10,19,3 } , { 9,18,2,11,25 } };
      return(m); }
    int [][] m = new int[n][n];
    return(m);
  }

  /* Fonction de creation d'une chaine de caracteres      */
  /* representant un nombre justifie a droite complemente */
  /* par des espaces                                      */
  /* v : entier a formater                                */
  /* larg : nombre de caracteres de la chaine resultat    */
  /* Resultat fonction : Chaine de caracteres             */

  public static String justifieADroite(int v,int larg) {
  /* Definition et initialisation de la chaine            */
  /* avec l'entier a formater                             */
    String s = ""+v;
  /* Ajout a gauche a la chaine d'autant de caracteres    */
  /* espace qu'il le faut pour que sa longueur devienne   */
  /* superieure ou egale a la largeur recherchee          */
    while ( s.length() < larg )
      s = " "+s;
  /* Resultat de la fonction                              */
    return(s);
  }

  /* Fonction d'affichage d'une matrice d'entiers         */
  /* m : tableau d'entiers a afficher                     */
  /* larg : largeur de chaque colonne                     */

  public static void affichageMatrice(int [][] m,int larg) {
    for ( int i = 0 ; i < m.length ; i++ ) {
  /* Pour toute les lignes de la matrice a afficher       */
      for ( int j = 0 ; j < m[0].length ; j++ ) {
  /* Affichage d'un entier de la ligne i                  */
  /* (sans aller a la ligne                               */
        Console.out.print(justifieADroite(m[i][j],larg+1)); }
  /* On va a la ligne quand tous les entiers d'une ligne  */
  /* ont ete affiches                                     */
      Console.out.println(); }
  }

  /* Fonction principale                                  */

  public static void main(String [] args) {
    Console.setTitle("TestMatriceMagique");
  /* Lecture au clavier du nombre de lignes               */
  /* et du nombre de colonnes de la matrice               */
    Console.out.print("Quelle taille  : ");
    int n = Integer.valueOf(Console.in.readLine()).intValue();
  /* Creation d'une matrice aleatoire de taille n         */
    int [][] m1 = creationMatriceAleatoire(n,100);
  /* Affichage du resultat du remplissage                 */
    Console.out.println("La matrice est :");
    affichageMatrice(m1,6);
  /* Affichage du resultat du test                        */
    Console.out.println("Matrice magique ? : "+testMatriceMagique(m1));
  /* Creation d'une matrice magique de taille n           */
    int [][] m2 = matriceMagique(n);
  /* Affichage du resultat du remplissage                 */
    Console.out.println("La matrice est :");
    affichageMatrice(m2,6);
  /* Affichage du resultat du test                        */
    Console.out.println("Matrice magique ? : "+testMatriceMagique(m2));
  }
}